<?php
/////////////////////////add to cart///////////////////////////////////



//products page
function wra_validate_add_cart_item($passed, $product_id, $quantity, $variation_id = '', $variations = '')
{
	global $woocommerce;
	if(!$product_id)
	{
		if(isset($_GET['elementor_page_id'])) $product_id=$_GET['elementor_page_id'];
		elseif(isset($_POST['add-to-cart'])) $product_id = $_POST['add-to-cart'];
	}	

	$product_quantity = wra_get_product_count($product_id);
	if($product_quantity!=-1)
	{
		$run = new Wra_Product_class;
		$run->update_product_stock($product_id, $product_quantity);			
	}
	return true;
}

 function wra_filter_woocommerce_update_cart_action_cart_updated( $cart_updated ) {
	

    global $woocommerce;
    $cart_items = $woocommerce->cart->get_cart();   
    //iterate thru all cart items
    foreach($cart_items as $cart_item) {

		$product_id= $cart_item['product_id'];

		$run = new Wra_Product_class;
		$product = $run->get_product($product_id);
		$product_quantity = $product->stock_quantity;

		$api_product_quantity = wra_get_product_count($product_id);
	
		if($api_product_quantity!=-1 && $product_quantity>$api_product_quantity)
		{
			WC()->cart->set_quantity( $cart_item['key'], $api_product_quantity );
			$cart_updated = false;

		}

		if ($api_product_quantity!=-1)
		{
			$run->update_product_stock($product_id, $api_product_quantity);
		}

    }

    if ( $cart_updated == false ) {
		wc_add_notice( __( '<div> متاسفانه تعداد موجودی محصول از تعداد مورد نیاز شما کمتر است و از این محصول برای سفارش در انبار موجود است. بابت مشکل پیش آمده پوزش میخواهیم.	   </div>', 'woocommerce' ), 'error' );
    
	
	}

    return $cart_updated;
}


function wra_my_custom_checkout_field_process() {
	$cart_updated =true;
	global $woocommerce;
    $cart_items = WC()->cart->get_cart();   
    //iterate thru all cart items
    foreach($cart_items as $cart_item) {

		$product_id= $cart_item['product_id'];
		$run = new Wra_Product_class;
		$product = $run->get_product($product_id);
		$product_quantity = $product->stock_quantity;

		$api_product_quantity = wra_get_product_count($product_id);

		if($api_product_quantity!=-1 && $product_quantity>$api_product_quantity)
		{
			//WC()->cart->set_quantity( $cart_item['key'], $api_product_quantity );
			$cart_updated = false;
		}

		if ($api_product_quantity!=-1)
			$run->update_product_stock($product_id, $api_product_quantity);

    }
    if ( $cart_updated == false ) {
		wc_add_notice( __( '<div> متاسفانه تعداد موجودی محصول از تعداد مورد نیاز شما کمتر است و از این محصول برای سفارش در انبار موجود است. بابت مشکل پیش آمده پوزش میخواهیم.	   </div>', 'woocommerce' ), 'error' );

	
	}
 
	 return $cart_updated;

}

function wra_run_mailchimp_query()
{

	if(isset($_GET['add-to-cart']) || (isset($_GET['wc-ajax']) && $_GET['wc-ajax']=='add_to_cart'))
	{
		wra_my_custom_checkout_field_process();
	}	
}



if (get_option('wra_state') == 'on' && get_option('wra_get_stock') == 'on')
{
	add_filter('woocommerce_add_to_cart_validation', 'wra_validate_add_cart_item', 10, 5);
	add_filter( 'woocommerce_update_cart_action_cart_updated', 'wra_filter_woocommerce_update_cart_action_cart_updated', 10, 1 );
	add_action('woocommerce_checkout_process', 'wra_my_custom_checkout_field_process');
	add_action( 'init', 'wra_run_mailchimp_query');
}





add_action('before_delete_post', function($id) {
    $post_type = get_post_type($id);
    if ($post_type === 'shop_order') {
		wra_delete_queue($id);
        return;
    }

   // $order = new WC_Order($id);
    //do some stuff with order meta data
}, 10, 1);






